# pull

Pulls changes from Azure DevOps server to the local repository. This by default includes creation of new scenarios from unlinked test cases (create) and changing scenarios of linked test cases (change).

See more details about the command in the [Pulling Test Case changes to local scenarios](/specsync/features/pull-features/two-way-synchronization.md) article.

## Options

In addition the the options listed here, all [common command line options](/specsync/reference/command-line-reference.md#common-command-line-options) can also be used.

| Option               | Description                                                                                                                                                                                                                                                                                                                           | Default                       |
| -------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| `--filter`           | A [local test case condition](/specsync/features/general-features/local-test-case-conditions.md) of scenarios that should be included in the current synchronization (e.g. `@current_sprint and @done`). See [Filters and scopes](/specsync/important-concepts/filters-and-scopes.md) for details.                                    | not filtered by tags          |
| `--sourceFileFilter` | A [local test case condition](/specsync/features/general-features/local-test-case-conditions.md) with source file predicates (glob patterns) of files that should be included in the current synchronization (e.g. `Folder1/**/*.feature`). See [Filters and scopes](/specsync/important-concepts/filters-and-scopes.md) for details. | not filtered by feature files |
| `--createOnly`       | If specified, the command will create new scenarios for the unlinked Test Cases only and the existing scenarios will not be modified. This setting automatically enables the 'enableCreatingNewLocalTestCases' pull setting.                                                                                                          | false                         |
| `--force`            | If specified, SpecSync changes scenarios even if there is no remote change and the scenario was not modified locally.                                                                                                                                                                                                                 | false                         |

## Examples

Pulls remote changes from Azure DevOps using the configured settings in the `specsync.json` configuration file:

```
dotnet specsync pull
```

Pulls remote changes using the specified [Personal Access Token (PAT)](/specsync/features/general-features/server-authentication-options.md#vsts-personal-access-tokens) for authentication:

```
dotnet specsync pull --user 52yny...........................nycsetda
```

Pulls remote changes related to the scenarios tagged with @ordering and @backend:

```
dotnet specsync pull --filter "@ordering and @backend"
```

Pulls unlinked Test Cases to new scenarios but ignores changed Test Cases:

```
dotnet specsync pull --createOnly
```

{% content-ref url="/pages/-LVwFCLgktB9AOsohdYl" %}
[Command line reference](/specsync/reference/command-line-reference.md)
{% endcontent-ref %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.specsolutions.eu/specsync/reference/command-line-reference/pull-command.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
